                                              //+------------------------------------------------------------------+
//|                                              Test Trading Model |
//|                                    Copyright  2013, W. B. Davis |
//|                                                                  |
//+------------------------------------------------------------------+

extern double TakeProfit =1000;
extern double Lots = 0.1;
extern double StopLoss =500;
extern double TrailingStop =250;
extern double MinProfit = 250;


extern bool CheckOncePerBar = true;
extern bool UseTimer = false;
extern bool UseLocalTime = false;

extern int StartMonth =6;
extern int StartDay = 15;
extern int StartHour= 7;
extern int StartMinute = 0;

extern int EndMonth = 12; 
extern int EndDay = 15;
extern int EndHour =2;
extern int EndMinute = 30;

datetime CurrentTimeStamp;

int cnt,BuyTicket,SellTicket,total;




int init()
   {
         CurrentTimeStamp=Time[0];
   }      

 // {
   
   //---- try to set new value
  // if(GlobalVariableSet("smi",1)==0)
  //  return(false);
    
  //} 
  //---- continue processing
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()


  {
   
  //Execute on bar open
   if(CheckOncePerBar == true)
	{
		int BarShift = 1;
		if(CurrentTimeStamp !=Time[0])
			{
				CurrentTimeStamp = Time[0];
				bool NewBar = true;
			}
		else NewBar = false;
	}
   else
	{
		NewBar = true;
		BarShift = 0;
	}		

   if(UseTimer == true)
   {
   
       //Convert start Time
     string StartConstant = StringConcatenate(Year(),".",StartMonth,".",StartDay,".",StartHour,".",StartMinute);
     
     datetime StartTime = StrToTime(StartConstant);
     if(StartMonth ==12 && StartDay == 31 && EndMonth ==1) int EndYear = Year() +1;
     else EndYear = Year();
     
     //Convert end Time
     string EndConstant = StringConcatenate(EndYear,".",EndMonth,".",EndDay,".",EndHour,".",EndMinute);
     
     datetime EndTime = StrToTime(EndConstant);
     
     //Choose local or server Time
     if(UseLocalTime == true) datetime CurrentTime = TimeLocal();
     else CurrentTime = TimeCurrent();
     
     //Check for trade condition
     if(StartTime <= CurrentTime && EndTime > CurrentTime)
      {
         bool TradeAllowed = true;
      }
      else TradeAllowed = false;
     } 
   else TradeAllowed = true;   
   
 
 
   
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
  
// indicators section
 
 double smi = iCustom(Symbol(),0,"Stochastic Momentum Index", 10,8,5,5,0,BarShift);
 double signal = iCustom(Symbol(),0,"Stochastic Momentum Index",10,8,5,5,1,BarShift);
 
 
 
 
 
  
 
         if(TakeProfit <1) 
         {
          Print("TakeProfit not entered");
          return(0);  // check TakeProfit
         }
          
     
    
   total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identifiedy
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());          
         
         return(0);
         
          
        }
       
     // Begin trade block--check if trading is open for the EA and that other EAs on your server are not active
    if(TradeAllowed == true)
     while (IsTradeContextBusy()) Sleep(10); 
     
     // Check for possible long position    
                      
          if (smi > signal)                        
                    
                         
        
                
          {
          BuyTicket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"Awesome Trading",16384,0,Green);
           if(BuyTicket>0)
             {
           if(OrderSelect(BuyTicket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice(),"smi ",smi, " smi_signal ",signal);
                         
             //SendNotification("Buy Order Signal "+Symbol());
             }
            else Print("Error opening BUY order : ",GetLastError());
              if(BuyTicket >0)
               {
              
                OrderSelect(BuyTicket,SELECT_BY_TICKET);
                double buy_entry_price = OrderOpenPrice();
               
                  
                
                if(StopLoss > 0.0) 
                
                 bool TicketMod = OrderModify(BuyTicket,buy_entry_price,buy_entry_price - (StopLoss * Point),buy_entry_price + (TakeProfit * Point),0,Yellow);
                  
                    Print("BuyTakeProfit ",TakeProfit,"  BuyStopLoss  ", StopLoss); 
               
                    Print("Error input of Stop Loss & Take Profit : ",GetLastError());
                
              } 
           return(0);
           
          }
            
      // check for short position (SELL) possibility
      
                
                 
                 if(smi < signal)
                                       
                  
        SellTicket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"Awesome Trading",16384,0,Red);
          if(SellTicket>0)
              {
              if(OrderSelect(SellTicket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice(),smi, " smi_signal ",signal);
               
                //SendNotification("Buy Order Signal "+Symbol());
             }
               else Print("Error opening SELL order : ",GetLastError());
             {
         
          if(SellTicket >0)
              {
               OrderSelect(SellTicket,SELECT_BY_TICKET);
               
                  double sell_entry_price = OrderOpenPrice();
                                 
                 
                  if(StopLoss > 0 )
                 
               
               OrderModify(SellTicket, sell_entry_price,sell_entry_price + (StopLoss * Point) ,sell_entry_price - (TakeProfit * Point) , 0);
                
                //TicketMod = OrderModify(SellTicket,OrderOpenPrice(),SellStopLoss,SellTakeProfit,0,Yellow);
                   
                    Print("SellTakeProfit ",TakeProfit,"  SellStopLoss  ", StopLoss); 
               
                     Print("Error input of Stop Loss & Take Profit : ",GetLastError());             
         //
             }   
        
         return(0); 
        
         }
         
         
         
          
      return(0);
     }
   // it is important to enter the market correctly, 
   // but it is more important to exit it correctly...   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
          {
            // should it be closed?
                                  
                                    if  (smi < 25.0)
                                       
                                    {
                                  OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet) ;Print("BUY order closed : ",OrderClosePrice());//close position
                          
                                  return(0); // exit
                         
                                  }
            // check for trailing stop
              if(TrailingStop>0)  
              {                 
               if(Bid-OrderOpenPrice()>(Point*MinProfit))
                {
                  if(OrderStopLoss()<(Bid-Point*MinProfit))
                    {
                   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*MinProfit,OrderTakeProfit(),Green);
                   return(0);
                    }
                 }

              }
          }
         else // go to short position
           {
             // should it be closed?
                                  
                                   if   (smi > -25.0)
                                    
                             {   
                              OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet) ;Print("SELL order closed : ",OrderClosePrice()); // close position                     
                                      
                 
                              return(0); // exit
                              }
            // check for trailing stop
            if(TrailingStop>0)  
             {                 
              if((OrderOpenPrice()-Ask)>(Ask+Point*MinProfit))
                 {
                  if(OrderStopLoss()>Ask+Point*MinProfit) 
                  {
                   OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*MinProfit,OrderTakeProfit(),Red);
                     return(0);
                   }
                }
              }
           }
        }
     }
   return(0);
  }
// the end.